def s2():
    """
    2 장
    통계적 추정과 가설 검정 기본기 다지기
    2.1 통계적 추정
    통계적 추정은 데이터를 사용하여 데이터를 발생시킨 모수의 값을 예측하는 방법입니다. 현재 내가
    가진 데이터를 발생시킨 분포의 모수를 값을 추정하는 방법에는 두 가지 방법이 존재합니다.
    • 점추정
    • 구간 추정
    점 추정의 경우 ADP 시험에는 잘 나오지 않으며, 구간 추정의 경우 기출 문제로 나온 적이 있으므로,
    정확하게 이해하고 있어야 합니다. 이번 챕터에 사용되는 기본적인 파이썬 모듈은 다음과 같습니다.
    import numpy as np
    import scipy.stats as sp
    import matplotlib.pyplot as plt
    구간추정
    모수가 존재할 것으로 예상되는 구간을 추정하는 방법을 구간 추정이라고 합니다. 이는 표본으로부터
    얻은 정보를 바탕으로 구간을 계산하고, 모집단의 모수(평균, 비율 등)가 이 구간 안에 존재할 확률이
    특정 수준 이상이라는 것을 보여주는 방법입니다.
    구간 추정을 공부 할 때 가장 중요한 점은 신뢰구간은 확률변수라는 것을 이해하는 것 입니다.
    위의 문장을 정확하게 이해했다면, 여러분의 통계 실력이 한층 높아지리라 생각합니다.
    모평균에 대한 구간 추정
    𝑋1
    , 𝑋2
    , ..., 𝑋𝑛을 정규분포 𝜇, 𝜎
    2를 따르는 확률변수라고 하고, 이 확률변수들에서 랜덤 표본들을
    뽑았을 때, 모평균 𝜇에 대한 100(1−𝛼) 신뢰구간은 다음과 같이 2가지 경우로 나눠 구할 수 있습니다.
    모분산 𝜎
    2이 알려져 있는 경우
    𝐶.𝐼. = 𝑋 ± 𝑧𝛼/2
    𝜎
    √
    𝑛
    통계적 추정과 가설 검정 기본기 다지기 | 39
    𝑧𝛼는 표준정규분포에서의 임계값(critical value)이라고 부르며, 100(1 − 𝛼) 백분위수를 의미합
    니다.
    모분산 𝜎
    2이 알려져 있지 않은 경우
    𝐶.𝐼. = 𝑋 ± 𝑡𝛼/2,𝑛−1 √
    𝑆𝑛
    𝑛
    𝑡𝛼,𝑛는 자유도가 𝑛인 𝑡분포에서의 임계값(critical value)이라고 부르며, 100(1−𝛼) 백분위수를
    의미합니다.
    모평균 계산 예제 파이썬으로 구하기 (모분산 𝜎를 모르는 경우)
    다음과 같이 데이터가 주어졌을 때, 모평균에 대한 95% 신뢰구간을 구해보도록 하겠습니다.
    # 표본 데이터
    data = [4.3, 4.1, 5.2, 4.9, 5.0, 4.5, 4.7, 4.8, 5.2, 4.6]
    먼저, 우리는 주어진 데이터로부터 표본 평균(𝑥)를 계산합니다.
    𝑥 =
    1
    𝑛
    𝑛
    ∑
    𝑖=1
    𝑥𝑖
    여기서 𝑛은 표본의 크기이고, 𝑥𝑖는 표본 데이터의 각 값입니다. 그 다음, 표본의 표준편차(𝑠)를 계산
    합니다.
    𝑠 = √
    1
    𝑛 − 1
    𝑛
    ∑
    𝑖=1
    (𝑥𝑖 − 𝑥)2
    표본의 표준편차를 표본의 크기의 제곱근으로 나누어 준 표준 오차 (standard error)를 계산합니다.
    𝑠.𝑒. =
    𝑠
    √
    𝑛
    마지막으로, 95% 신뢰구간은 표본 평균에서 ± 표준 오차의 𝑡0.025,9 = 2.26배 떨어진 범위가 됩니다.
    데이터를 통하여 모평균에 대한 구간 추정을 수행하는 파이썬 코드를 보겠습니다.
    from scipy.stats import t
    # 표본 평균
    mean = np.mean(data)
    # 표본 크기
    n = len(data)
    # 표준 오차
    se = np.std(data, ddof=1) / np.sqrt(n)
    40 | 통계적 추정과 가설 검정 기본기 다지기
    2
    # 95% 신뢰구간
    round(mean - t.ppf(0.975, n-1) * se, 3); round(mean + t.ppf(0.975, n-1) * se, 3)
    ^༈ 4.469
    ^༈ 4.991
    같은 신뢰구간을 t.interval()를 사용하여 구하는 방법은 다음과 같습니다.
    # t.interval로 구하기
    ci = t.interval(0.95, loc=mean, scale=se, df=n-1)
    print("95% 신뢰구간: ", [round(i, 3) for i in ci])
    ^༈ 95% 신뢰구간: [4.469, 4.991]
    참고로 ADP 25회 기출문제의 경우, 𝑧0.05, 𝑧0.025, 𝑡0.05, 그리고 𝑡0.025 의 값을 모두 제공하여,
    시험자가 정확한 공식을 사용할 수 있는지 평가하였습니다.
    2.2 통계적 검정
    통계 검정은 “모집단 분포의 모수에 대한 가설의 참, 거짓 여부”를 관찰된 데이터가 우연인지 아니면
    특정한 효과가 있는지를 판단하여 검증하는 과정입니다. 이를 위해 귀무가설(null hypothesis, 𝐻0
    )
    과 대립가설(alternative hypothesis, 𝐻𝑎 또는 𝐻1
    )이라는 두 가지 가설을 설정하고, 귀무가설이
    참이라는 가정하에 주어진 검정통계량 값보다 극단적인 값을 관찰 할 확률을 계산하여 결과를 도출합
    니다.
    검정에서 사용되는 가설들
    귀무가설 ( 𝐻0
    : Null Hypothesis )
    귀무가설은 기본적으로 전제가 되는 가정 혹은 기존에 참이라고 받아들여지고 있는 가정입니다.
    𝐻0
    ∶ 𝜇 = 𝜇0
    • 귀무가설은 위와 같이 항상 등호(=) 형식을 띄고 있습니다. 꼭 기억해 주세요!
    • 귀무가설을 말로 표현 할 때, 보통 ‘0과 같다’, ‘차이가 없다’, 혹은 ‘효과가 없다’ 라고 하는 형태를
    많이 띕니다. (Null의 의미)
    귀무가설 예 업체 A에서 생산되는 베어링 평균 지름의 길이는 3 cm 이다.
    𝐻0
    ∶ 𝜇 = 3
    한 가지 주목 할 점은 앞에서 귀무가설을 기호로 표현함에 있어서, 𝜇0 가 3으로 설정 된 상황입니다.
    통계적 검정 | 41
    대립가설 ( 𝐻1
    : Alternative Hypothesis )
    대립가설은 현재까지 받아들여지고 있는 귀무가설과 대립되는 가설입니다. 따라서, 대립가설을 받아
    들이기 위해서는 확실한 증거 필요합니다.
    • 귀무가설의 반대 상황을 나타냅니다.
    • 귀무가설이 기각 되었을 때 받아들여지게 된다.
    대립가설 예 업체 A에서 생산되는 베어링 평균 지름의 길이는 3 cm 가 아니다.
    𝐻𝐴 ∶ 𝜇 ≠ 3
    위와 같은 형태의 대립가설을 양측검정(two‑tailed test)에 대응하는 대립 가설이라고 합니다. 하
    지만, 다음과 같이 경우에 따라서 특정 방향에만 우리의 관심이 있는 경우가 있습니다.
    업체 A에서 생산되는 베어링 평균 지름의 길이는 3 cm 보다 작다.
    𝐻𝐴 ∶ 𝜇 < 3
    업체 A에서 생산되는 베어링 평균 지름의 길이는 3 cm 크다.
    𝐻𝐴 ∶ 𝜇 > 3
    위의 두 가지 형태의 대립가설을 단측검정(one‑tailed test)에서의 대립가설이라고 부릅니다.
    검정통계량이란?
    검정통계량(test statistic)은 가설 검정에 사용되는 확률변수입니다. 데이터를 사용하여 검정통계량의
    실현치를 계산하고, 그 값에 따라 귀무가설을 기각 할 지 말지에 대한 통계적 의사 결정을 내립니다.
    Z 검정통계량 (Z‑test statistic)
    𝑍 검정통계량은 표본 평균이 정규분포를 따르는 경우에 모집단의 평균을 검정할 때 사용할 수 있습니
    다. 일반적으로, 모집단의 분산이 알려져 있고 표본 크기가 충분히 클 때 사용됩니다.
    모분포의 분산 𝜎
    2을 알고 있는 경우, 𝑛개의 표본으로 만든 표본평균 𝑋의 분포를 표준화시켜 가설
    검정을 할 수 있습니다. 𝑍 검정통계량은 다음과 같습니다.
    𝑍 = 𝑋 − 𝜇0
    𝜎/√
    𝑛 ⟶ 𝒩(0, 1 𝑛 2
    )
    위에서 알 수 있듯, 𝑛이 커지면, Z 검정통계량의 분포는 표준정규분포로 수렴하게 됩니다. 따라서, 𝑍
    검정을 수행하기 전에 다음 가정 2가지가 충족되어야 합니다.
    1. 모집단의 분산이 알려져 있어야 합니다.
    2. 모집단이 정규분포를 따르거나, 표본 크기가 충분히 커야 합니다. (일반적으로 𝑛 ≥ 30).
    42 | 통계적 추정과 가설 검정 기본기 다지기
    2
    스튜던트 t 검정통계량
    많은 경우 실무에서 기본적으로 사용하는 검정통계량이며, 스튜던트 정리에 기반하여 검정통계량의
    분포가 유도되었습니다. 따라서, t 검정을 적용하기 위해서는 스튜던트 정리에서 가정하는 가정들을
    만족해야만 검정의 결과를 믿을 수 있습니다.
    따라서 𝑡분포의 정의에 의하여 𝑡 검정 통계량은 자유도가 𝑛 − 1이 𝑡분포를 따르게 됩니다.
    𝑇 = 𝑋 − 𝜇0
    𝑆/√
    𝑛
    ∼ 𝑡𝑛−1
    여기서 𝑋 는 표본 평균 확률변수, 𝑆 은 표본 표준편차 확률변수, 마지막으로 𝑛은 표본의 크기를 나타
    냅니다.
    스튜던트 정리
    정말 많이 사용되는 𝑡 검정의 근간을 이루는 정리이므로 꼭 알아둬야 합니다. ADP 시험에서 𝑡검정을
    적용하기 전, 가정 체크를 하는 근본적인 이유가 됩니다.
    스튜던트 정리
    평균이 𝜇이고 분산이 𝜎
    2 인 정규분포를 따르는 독립인 𝑋1
    , 𝑋2
    , ..., 𝑋𝑛 에 대하여 다음이 성립
    한다.
    1. 𝑋는 정규분포 평균이 𝜇, 분산이 𝜎
    2/𝑛인 분포를 따른다.
    2. 𝑋과 𝑆
    2은 독립이다.
    3. (𝑛−1)𝑆2
    𝜎2 은 자유도가 𝑛 − 1인 카이제곱분포를 따른다.
    위에서 사용된 𝑋와 𝑆
    2는 다음과 같이 정의한다.
    𝑋 =
    ∑
    𝑛
    𝑖=1 𝑋𝑖
    𝑛
    𝑆
    2 =
    ∑
    𝑛
    𝑖=1 (𝑋𝑖 − 𝑋)2
    𝑛 − 1
    𝑡 분포 확률변수
    자유도가 𝜈 인 𝑡 분포를 따르는 확률변수는 다음과 같이 정의 할 수 있습니다.
    𝑍
    √𝑉 /𝜈
    여기서 𝑍 는 표준정규분포, 𝑉 는 자유도가 𝜈 인 카이제곱분포를 따르는 확률변수입니다.
    𝑡 검정통계량의 분포 유도
    𝑡 검정 통계량은 다음과 같이 2가지 파트로 생각해 볼 수 있습니다.
    통계적 검정 | 43
    𝑋 − 𝜇0
    𝑆/√
    𝑛
    =
    𝑋−𝜇0
    𝜎/√
    𝑛
    𝑆
    𝜎
    =
    𝑋−𝜇0
    𝜎/√
    𝑛
    √(𝑛−1)𝑆2
    𝜎2 / (𝑛 − 1)
    스튜던트 정리의 1번에 의하여
    𝑋 − 𝜇0
    𝜎/√
    𝑛
    ∼ 𝒩 (0, 1)
    이 성립합니다. 또한 스튜던트 정리의 3번
    (𝑛 − 1) 𝑆2
    𝜎
    2
    ∼ 𝜒2
    𝑛−1
    에 의하여 𝑆/𝜎는 자유도 𝑛 − 1인 카이제곱분포를 따르는 확률변수를 그것의 자유도로 나누고 제곱
    근을 씌운 꼴로 볼 수 있다.
    𝑆
    𝜎
    = √(𝑛 − 1) 𝑆2
    𝜎
    2
    / (𝑛 − 1)
    따라서 𝑡분포의 정의에 의하여 𝑡 검정 통계량은 자유도가 𝑛 − 1이 𝑡분포를 따르게 된다.
    𝑋 − 𝜇0
    𝑆/√
    𝑛
    ∼ 𝑡𝑛−1
    위의 정리에서와 마찬가지로
    • 𝑋는 표본 평균 확률변수
    • 𝑆 은 표본 표준편차 확률변수
    • 𝑛은 표본의 크기
    를 의미합니다.
    t 검정통계량 계산
    가장 기본적인 검정 형태인 1 표본 𝑡 검정에 대하여 데이터를 사용하여 공부해봅시다. 기본 가정은 모
    분산 𝜎
    2을 모른다는 것이며, 관찰값들이 하나의 동일한 분포에서 독립적으로 뽑혔다는 것을 가정하고
    있습니다. 이러한 상태에서 모평균 𝜇이 특정값과 같은지, 같지 않는지에 대한 검정입니다.
    목표
    데이터가 주어졌을 때, 주어진 관찰값 (표본)들을 발생시킨 분포의 모평균이 7인지 검정하려고 합니다.
    예제 데이터
    다음 15개의 데이터가 있다고 가정합시다.
    4.62, 4.09, 6.2, 8.24, 0.77, 5.55, 3.11, 11.97, 2.16, 3.24, 10.91, 11.36, 0.87, 9.93, 2.9
    가설 설정
    대응하는 귀무가설, 대립가설을 다음과 같이 설정할 수 있습니다.
    44 | 통계적 추정과 가설 검정 기본기 다지기
    2
    𝐻0
    ∶ 𝜇 = 7 𝑣𝑠. 𝐻𝐴 ∶ 𝜇 ≠ 7
    이 경우, 검정은 양측검정에 속하게 됩니다.
    검정통계량 값 계산
    𝑡 =
    𝑥 − 𝜇0
    𝑠/√
    𝑛
    위의 데이터를 사용하여 계산된 𝑡 검정 통계량 값은 약 −1.279가 나옵니다. 이 값은 스튜던트 정리
    에 의하여, 자유도가 14인 𝑡 분포에서 뽑혀진 관찰값이라 생각할 수 있습니다.
    x = [4.62, 4.09, 6.2, 8.24, 0.77, 5.55, 3.11,
    11.97, 2.16, 3.24, 10.91, 11.36, 0.87, 9.93, 2.9]
    t_value = (np.mean(x)-7) / (np.std(x, ddof=1) / np.sqrt(len(x)))
    round(t_value, 3)
    ^༈ -1.279
    기각역
    기각역은 가설 검정에서 귀무가설이 기각시킬 수 있는 영역을 의미하고, 구체적으로 주어진 귀무가설이
    참인 상황에서 잘 볼 수 없는 표본들이 위치한 영역을 의미합니다.
    • 기각역은 유의수준 𝛼와 가설의 모양에 따라서 정해집니다.
    위의 양측 검정에서는 𝑡 검정 통계량이 따르는 분포인 자유도가 𝑛−1인 𝑡분포의 양 끝단 (각 끝에서
    확률을 𝛼/2씩 차지하는) 부분입니다. 다음은 유의수준 𝛼 = 0.05에 해당하는 기각역을 시각화하는
    파이썬 코드입니다.
    from scipy.stats import t
    n = len(x)
    x = np.arange(-3, 3, 0.1)
    y = t.pdf(x, df=n-1)
    reject_range = t.ppf(0.975, df=n-1)
    plt.plot(x, y, color='k')
    plt.axhline(0, color='black', linewidth=0.5)
    plt.fill_between(x, y,
    where=(x < -reject_range) | (x > reject_range),
    color='yellow')
    plt.plot(t_value, 0, 'ro') # 검정통계량 표현
    plt.show()
    통계적 검정 | 45
    3 2 1 0 1 2 3
    0.00
    0.05
    0.10
    0.15
    0.20
    0.25
    0.30
    0.35
    0.40
    그림 2.1: 자유도가 14인 t분포의 양측검정 기각역 시각화
    기각역에 검정 통계량 값이 속하게 되면 귀무가설을 기각하게 됩니다. 이번 예제에서는 검정통계량
    값이 기각역에 속하지 않으므로, 귀무가설을 기각할 수 없습니다.
    유의 확률 (p‑value)
    귀무가설이 참이라는 가정하에서 검정통계량 값이 주어진 관측값과 같거나, 더 극단적인 값을 얻게
    될 확률을 의미합니다. 아래 그림의 어두운 부분에 해당하는 확률값이 양측 검정에서의 p‑value를
    표현한 것입니다.
    3 2 1 0 1 2 3
    0.00
    0.05
    0.10
    0.15
    0.20
    0.25
    0.30
    0.35
    0.40
    그림 2.2: 자유도가 14인 t 분포의 양측검정 p‑value 시각화
    가설 형태와 p‑value 계산
    가설의 모양에 따라서 p‑value 계산 시, 양쪽을 고려할 지, 한쪽 만을 고려할 지 결정합니다.
    46 | 통계적 추정과 가설 검정 기본기 다지기
    2
    • 양측 검정의 대립가설 형태는 양쪽을 모두 고려합니다.
    𝐻𝑎
    ∶ 𝜇 ≠ 𝜇0 인 경우 2𝑃(𝑇 ≥ |𝑡|)
    3 2 1 0 1 2 3
    0.0
    0.1
    0.2
    0.3
    0.4
    0.5
    |t|
    그림 2.3: 양측검정 p‑value 시각화
    양측검정 p༡value의 경우, 검정통계량 값에 대응하는 반대편 영역의 확률까지 고려하기 때문에
    확률의 2배로 계산된다는 것을 꼭 기억합시다.
    • 단측검정의 대립가설 형태는 한쪽 만을 고려합니다.
    𝐻𝑎
    ∶ 𝜇 > 𝜇0 인 경우 𝑃(𝑇 ≥ 𝑡)
    3 2 1 0 1 2 3
    0.0
    0.1
    0.2
    0.3
    0.4
    0.5
    t
    그림 2.4: 단측검정 p‑value 시각화
    통계적 검정 | 47
    𝐻𝑎
    ∶ 𝜇 < 𝜇0 인 경우 𝑃(𝑇 ≤ 𝑡)
    3 2 1 0 1 2 3
    0.0
    0.1
    0.2
    0.3
    0.4
    0.5
    t
    그림 2.5: 단측검정 p‑value 시각화
    검정력 (Test power)
    귀무가설이 참이 아니라는 전제하에, 유의수준이 𝛼인 검정이 귀무가설을 기각할 확률을 의미합니다.
    • test power가 높을 수록 좋은 검정 방법이라 말할 수 있습니다.
    • 일반적으로 검정력 0.8이상인 검정을 좋은 검정이라고 말합니다.
    유의수준과 검정력
    유의수준 𝛼는 검정 방법을 반복해서 시행했을 때, 얼마나 믿을 만 한가를 나타내는 측정 요소입니다.
    • 유의수준 0.05의 의미: 주어진 검정 방법을 계속해서 시행했을 경우, 귀무가설이 참이라는 전제
    하에 5% 정도 옳지 않는 판단 (귀무가설을 기각)을 내리게 됩니다.
    유의수준은 다음 그림에서처럼 귀무가설이 참일때, 기각역에 해당하는 확률을 의미합니다.
    반면, 검정의 검정력은 대립가설이 참이라는 가정하에서, 귀무가설이 기각될 확률을 의미합니다.
    따라서, 대립가설이 참일때의 특정 모수값에 해당하는 분포에서 기각역에 해당하는 확률을 의미하게
    48 | 통계적 추정과 가설 검정 기본기 다지기
    2
    된다.
    t༡test 는 언제 작동을 잘 할까?
    ADP 자격증 시험 답안 작성 필수 팁
    • 통계적 검정을 하기 전, 검정의 가정을 만족하는 상황인지 필수적으로 체크 해야 합니다.
    • 이론적으로 𝑡 검정은 자료가 꼭! 정규분포를 따른다는 가정이 만족해야만 잘 작동하는 통계적
    검정1입니다. 따라서 검정을 시작하기 전에 정규분포를 따르는 것을 꼭 체크해줘야 합니다.
    • 정규성을 만족을 하지 못한다면? 다른 검정을 시도해야 합니다.
    표본의 크기가 작은 경우 ( 𝑛 < 30)
    • 표본의 원 분포가 정규분포를 따르면 적용 할 수 있습니다.
    표본의 크기가 큰 경우 ( 𝑛 > 30)
    • 중심극한정리에 따라서 표본 평균이 정규분포를 따르는 것이 어느 정도 보장됩니다. 따라서, 𝑡
    검정이 아닌 정규분포로 근사해서 사용할 수 있습니다. 𝑡 분포의 𝑛 무한대인 경우가 표준정규분
    포가 된다는 사실도 알고 있으면 좋겠죠?
    2.3 데이터가 특정 분포를 따르는지 체크하는 방법
    𝑡 검정 수행을 위하여 데이터가 정규분포를 따르는지 체크해보아야 합니다. 이 챕터에서는 좀 더 일반
    적으로 데이터가 특정분포 (정규분포 포함)를 따르는지 체크하는 방법을 배워봅시다.
    Quantile‑Quantile plot
    • QQ Plot의 작동원리 직관: 이론적으로 예상하는 백분위수와 데이터를 사용하여 계산 된 백분
    위수를 비교
    데이터에 대응하는 백분위수 구하기
    분위수는 데이터를 일정 그룹으로 나누는 기준이 되는 수를 말하고, 이 중 데이터를 100개 그룹으로
    나누는 기준이 수들을 백분위수 (percentile) 이라고 말합니다.
    1해당 문제는 위키피디아의 선형계획법 페이지에서 가져옴.
    데이터가 특정 분포를 따르는지 체크하는 방법 | 49
    p‑th percentile 구하는 방법
    𝑥1
    , ..., 𝑥𝑛
    와 같이 𝑛개의 데이터가 존재할 때 p번째 백분위수는 다음과 같이 구합니다.
    1. 데이터 순서대로 정렬: 𝑥(1), ..., 𝑥(𝑛)
    • 𝑥(1) ≤ ... ≤ 𝑥(𝑛)
    2. (𝑛 + 1) × 𝑝/100 를 계산해서 정수부분과 소수 부분을 구분하기
    • 정수부분 j, 소수부분 h
    3. p‑th percentile 구하는 공식 적용
    • (1 − ℎ)𝑥(𝑗) + ℎ𝑥(𝑗+1)
    위의 과정을 간단한 숫자를 사용해서 구해봅시다. 생각보다 너무 쉬우니, 미리 겁먹지 마세요! 수식을
    두려워하지 않는 연습 과정이라고 생각합시다.
    155, 126, 27, 82, 115
    위와 5개 숫자를 사용해서 50 백분위수를 구해봅시다.
    • 중앙값 (50th percentile): 115
    • 3사분위수 (75th percentile): 140.5
    import numpy as np
    x = np.array([155, 126, 27, 82, 115])
    #numpy의 percentile()를 통해 분위수 구할 수 있음
    q2 = np.percentile(x, 50) #중앙값 (2사분위수)
    q3 = np.percentile(x[x>q2], 50) #3사분위수
    q1 = np.percentile(x[x<q2], 50) #1사분위수
    print('1사분위수:', q1)
    ^༈ 1사분위수: 54.5
    print('2사분위수:', q2)
    ^༈ 2사분위수: 115.0
    print('3사분위수:', q3)
    ^༈ 3사분위수: 140.5
    50 | 통계적 추정과 가설 검정 기본기 다지기
    2
    데이터에 대응하는 백분위를 한꺼번에 구하는 방법
    이번에는 반대로, 데이터에 대응하는 백분위 (percent)를 구하는 방법입니다.
    155, 126, 27, 82, 115
    데이터가 주어졌을 때 대응하는 백분위를 한꺼번에 구하는 방법은 다음과 같습니다.
    1. 데이터를 순서를 부여한다.
    2. 𝑛 + 1로 나눠줌.
    x = np.array([155, 126, 27, 82, 115])
    np.sort(x)
    ^༈ array([ 27, 82, 115, 126, 155])
    ranks = sp.rankdata(sorted(x)) #sp.rankdata() 안에 정렬된 array 넣기
    ranks / (len(x) + 1)
    ^༈ array([0.16666667, 0.33333333, 0.5 , 0.66666667, 0.83333333])
    • 순서와 상관없이 대응되는 백분위 구하기
    x
    ^༈ array([155, 126, 27, 82, 115])
    sp.rankdata(x) / (len(x) + 1)
    ^༈ array([0.83333333, 0.66666667, 0.16666667, 0.33333333, 0.5 ])
    QQ plot을 위한 예제 데이터 다음 데이터에 대응하는 QQ plot을 그려보도록 합시다.
    4.62, 4.09, 6.2, 8.24, 0.77, 5.55, 3.11, 11.97, 2.16, 3.24, 10.91, 11.36, 0.87
    데이터에 대응하는 백분위 구하기 앞에서 살펴본 방식으로 백분위를 구합니다.
    data_x = np.array([4.62, 4.09, 6.2, 8.24, 0.77, 5.55,
    3.11, 11.97, 2.16, 3.24, 10.91, 11.36, 0.87])
    data_percent = sp.rankdata(data_x) / (len(data_x) + 1)
    print(data_percent[:6])
    ^༈ [0.5 0.42857143 0.64285714 0.71428571 0.07142857 0.57142857]
    데이터가 특정 분포를 따르는지 체크하는 방법 | 51
    이론적인 백분위수 (percentile) 구하기 위에서 구한 백분위에 대응하는 이론적인 백분위수를 구
    합니다. 특정 분포의 이론적인 백분위수는 그 분포의 누적분포함수의 역함수를 사용해서 구할 수
    있으므로, Python에서 제공하는 <dist.name>.ppf() 함수를 사용합니다.
    • 데이터의 백분위(%)에 대응하는 이론적인 정규분포의 백분위수(percentile) 구하기
    theory_x = sp.norm.ppf(data_percent, np.mean(data_x), np.std(data_x))
    print(theory_x[:6])
    ^༈ [5.62230769 4.94909284 6.99148158 7.73885752 0.14258901 6.29552254]
    QQ plot 의 아이디어
    만약 데이터가 정규분포를 따른다면 이론적으로 구한 값과 데이터에서 구해진 정보가 거의 비슷한
    값을 가지고 있어야 할 것 입니다.
    plt.scatter(theory_x, data_x, color='k')
    plt.plot([0,12], [0,12], 'k')
    plt.title('QQplot')
    plt.xlabel('theory_x')
    plt.ylabel('data_x')
    plt.show()
    0 2 4 6 8 10 12
    theory_x
    0
    2
    4
    6
    8
    10
    12
    data_x
    QQplot
    따라서, 45도 대각선을 기준으로 점들이 찍혀있다면 데이터가 특정분포를 따르는 것이라고 판단할
    수 있습니다. QQ plot은 주어진 데이터를 y 값으로, 앞에서 구한 이론적인 백분위수를 x 값으로하여,
    산점도를 그립니다.
    QQ plot 실제 시험장 코드 실제 시험장에서는 pingouin 패키지의 qqplot() 함수를 사용합니다.
    qqplot() 함수가 간혹 모든 점들을 표시하지 않는 경우가 있습니다. 이 경우, ylim()과 xlim()를 사용
    해서 조정해줍니다.
    52 | 통계적 추정과 가설 검정 기본기 다지기
    2
    # pip install pingouin
    import pingouin as pg
    ax = pg.qqplot(data_x, dist='norm', confidence=0.95)
    plt.ylim(-3, 3);
    plt.xlim(-3, 3);
    plt.show()
    3 2 1 0 1 2 3
    Theoretical quantiles
    3
    2
    1
    0
    1
    2
    3
    Ordered quantiles
    R
    2 = 0.935
    Shapiro‑Wilk 검정
    표본 크기가 50개가 안되는 작은 데이터들의 정규성 검정을 위하여 고안된 검정입니다. 좋은 검정력
    (power)을 가지고 있는 것 때문에 많이 사용합니다.
    • 정규분포 전용 검정: 모든 검정 대비 최고 검정력
    귀무가설과 대립가설
    • 𝐻0
    : 데이터가 정규분포를 따른다.
    • 𝐻𝐴: 데이터가 정규분포를 따르지 않는다.
    검정통계량
    𝑊 =
    (∑𝑛
    𝑖=1 𝑎𝑖𝑥(𝑖))
    2
    ∑
    𝑛
    𝑖=1(𝑥𝑖 − 𝑥)2
    SW 검정통계량의 분포를 유도할 수 없고, 필요도 없지만, 다음과 같은 특성들은 알아둬야 합니다.
    • 𝑎𝑖 들은 미리 정해진 숫자들, 𝑥(𝑖) 들은 순위 표본을 의미합니다.
    • 귀무가설이 참 이면, 이론적으로 1이 나오도록 설계되어 있습니다.
    • 𝑊 값은 0에서 1사이의 값을 갖습니다.
    • 𝑊 값이 0과 가까우면 가까울 수록 정규분포와는 다르게 분포되어 있음을 뜻합니다.
    데이터가 특정 분포를 따르는지 체크하는 방법 | 53
    • 단점: 너무 민감한 검정. 데이터의 분포가 타켓 분포와 조금만 달라도 p‑value가 너무 작게 나와
    귀무가설이 기각됩니다.
    • 해결책: 시각화 기법과 같이 사용해서 보여주도록 합니다.
    – QQplot과 Density를 꼭 같이 사용
    파이썬으로 Shapiro‑Wilk 검정 하는 법
    파이썬 sp.shapiro(data) 코드를 사용합니다.
    x = [4.62, 4.09, 6.2, 8.24, 0.77, 5.55, 3.11,
    11.97, 2.16, 3.24, 10.91, 11.36, 0.87, 9.93, 2.9]
    print(sp.shapiro(x))
    ^༈ ShapiroResult(statistic=0.9116314053535461, pvalue=0.14343824982643127)
    결과를 살펴보면 p༡value 값이 상당히 크므로 유의수준 5%하에서 귀무가설을 기각할 수 없습니다.
    데이터를 사용하여 누적분포함수 그리기
    데이터에 들어있는 분포의 정보를 사용하여 누적분포함수를 구하는 방법입니다. statsmodels에서
    제공하는 ECDF() 함수를 사용하면 됩니다.
    • 예제 데이터에 대응하는 누적분포함수 그리기
    import numpy as np
    import matplotlib.pyplot as plt
    from statsmodels.distributions.empirical_distribution import ECDF
    data_x = [4.62, 4.09, 6.2, 8.24, 0.77, 5.55, 3.11,
    11.97, 2.16, 3.24, 10.91, 11.36, 0.87]
    ecdf = ECDF(data_x)
    x = np.linspace(min(data_x), max(data_x))
    y = ecdf(x)
    plt.plot(x,y,marker='_', linestyle='none')
    plt.title("Estimated CDF")
    plt.xlabel("X༡axis")
    plt.ylabel("ECDF")
    plt.show()
    54 | 통계적 추정과 가설 검정 기본기 다지기
    2
    2 4 6 8 10 12
    X-axis
    0.2
    0.4
    0.6
    0.8
    1.0
    ECDF
    Estimated CDF
    Anderson‑Darling test
    이론적인 누적분포함수와 데이터에 들어있는 누적분포함수가 얼마나 비슷한 지 체크하여 검정하는
    방법입니다. 이 검정의 귀무가설과 대립가설은 다음과 같습니다.
    • 𝐻0
    : 데이터가 target 분포를 따른다.
    • 𝐻𝐴: 데이터가 target 분포를 따르지 않는다.
    이론적인 CDF vs. Estimated CDF 거리
    • AD 검정의 작동원리 직관: 귀무가설이 참이라면 이론적인 누적분포함수와 표본에서 구한 분포
    함수의 차이가 작아야지 않을까?
    𝐴2 = 𝑛 ∫∞
    −∞
    (𝐹𝑛(𝑥) − 𝐹(𝑥))2
    𝐹(𝑥) (1 − 𝐹(𝑥)) 𝑑𝐹(𝑥),
    Anderson‑Darling 검정은 정규분포 검정에도 특히 좋지만 다른 분포 검정에도 사용 가능합니다.
    from scipy.stats import norm
    np.random.seed(2021)
    sample_data = norm.rvs(loc = 0, scale = 1, size = 100)
    ecdf = ECDF(sample_data)
    x = np.linspace(min(sample_data), max(sample_data))
    y = ecdf(x)
    plt.scatter(x, y)
    plt.title("Estimated CDF vs. CDF")
    데이터가 특정 분포를 따르는지 체크하는 방법 | 55
    # add Nomrmal CDF
    k = np.arange(-3, 3, 0.1)
    plt.plot(k, norm.cdf(k), color='k')
    plt.show()
    3 2 1 0 1 2 3
    0.0
    0.2
    0.4
    0.6
    0.8
    1.0
    Estimated CDF vs. CDF
    어떤 류의 검정을 할 수 있나? 이론적인 CDF를 알고있는 모든 분포들에 대하여 적용 가능합니다. 즉,
    특정 분포를 따르는지에 대한 검정을 수행 가능합니다. 다만, 실무에서는 정규분포를 체크하는데 많이
    쓰입니다.
    from scipy.stats import anderson
    ad_test = anderson(x) # p༡value 꺼내는 법
    print('검정통계량',ad_test[0])
    ^༈ 검정통계량 0.534500239332317
    print('임계값:',ad_test[1]) #p༡value가 많이 다름
    ^༈ 임계값: [0.538 0.613 0.736 0.858 1.021]
    print('유의수준:',ad_test[2])
    ^༈ 유의수준: [15. 10. 5. 2.5 1. ]
    결과를 살펴보면, p༡value 값이 Shapiro‑Wilk와 마찬가지로 크게 나왔으므로, 유의수준 5하에서
    𝐻0 기각 할 수 없습니다.
    56 | 통계적 추정과 가설 검정 기본기 다지기
    2
    생각해보기
    • AD 검정통계량의 분모에 들어있는 𝐹(𝑥)(1 − 𝐹(𝑥)) 부분은 어떤 의미일까요?
    • Kolmogorov‑Smirnov 검정통계량과 차이점은 무엇일까요?2,3
    𝐷𝑛 = sup
    𝑥
    |𝐹𝑛(𝑥) − 𝐹(𝑥)|
    연습문제
    신뢰구간 구하기
    다음은 한 고등학교의 3학년 학생들 중 16명을 무작위로 선별하여 몸무게를 측정한 데이터이다. 이
    데이터를 이용하여 해당 고등학교 3학년 전체 남학생들의 몸무게 평균을 예측하고자 한다.
    79.1, 68.8, 62.0, 74.4, 71.0, 60.6, 98.5, 86.4, 73.0, 40.8, 61.2, 68.7, 61.6, 67.7, 61.7, 66.8
    단, 해당 고등학교 3학년 남학생들의 몸무게 분포는 정규분포를 따른다고 가정한다.
    1) 모평균에 대한 95% 신뢰구간을 구하세요.
    2) 작년 남학생 3학년 전체 분포의 표준편차는 6kg 이었다고 합니다. 이 정보를 이번 년도 남학생
    분포의 표준편차로 대체하여 모평균에 대한 90% 신뢰구간을 구하세요.
    신형 자동차의 에너지 소비효율 등급
    슬통 자동자는 매해 출시되는 신형 자동차의 에너지 소비효율 등급을 1등급으로 유지하고 있다. 22
    년 개발된 신형 모델이 한국 자동차 평가원에서 설정한 에너지 소비 효율등급 1등급을 받을 수 있을지
    검정하려한다. 평가원에 따르면 1등급의 기준은 평균 복합 에너지 소비효율이 16.0 이상인 경우 부여
    한다고 한다.
    다음은 신형 자동차 15대의 복합 에너지소비효율 측정한 결과이다.
    15.078, 15.752, 15.549, 15.56, 16.098, 13.277, 15.462, 16.116, 15.214, 16.93, 14.118, 14.927,
    15.382, 16.709, 16.804
    표본에 의하여 판단해볼때, 현대자동차의 신형 모델은 에너지 효율 1등급으로 판단할 수 있을지
    판단해보시오. (유의수준 1%로 설정)
    1. 𝑡 검정을 위한 가정체크를 진행하세요.
    2. 검정을 위한 가설을 명확하게 서술하시오.
    3. 검정통계량 계산하시오.
    4. p‑value을 구하세요.
    5. 주어진 유의수준에 대응하는 기각역은 얼마인가요?
    6. 현대자동차의 신형 모델의 평균 복합 에너지 소비효율에 대하여 95% 신뢰구간을 구해보세요.
    2https://en.wikipedia.org/wiki/Kolmogorov%E2%80%93Smirnov_test
    3Anderson‑Darling test는 왜 tail에 웨이트를 주는 것인가? https://encyclopediaofmath.org/wiki/Anderson‑
    Darling_statistic
    데이터가 특정 분포를 따르는지 체크하는 방법 | 57
    7. 평균 복합에너지 소비효율이 15이라면, 위의 검정의 검정력을 구하세요. (단, 검정력 계산시,
    모분포의 표준편차를 1라고 가정한다.)
    검정력을 만족하는 표본 개수
    위의 슬통 자동차 문제에서 주어진 표본들을 사용해서 신형 자동차의 평균 에너지 소비효율이 16인지
    아닌지를 유의수준 5%하에서 검정을 진행하려고 한다. 단, 모분포의 표준편차를 2라고 가정한다.
    1. 신형 자동차의 평균 에너지 소비효율이 15일때, 주어진 검정의 검정력을 구하세요.
    2. 신형 자동차의 평균 에너지 소비효율이 15일때, 주어진 검정의 검정력을 80%로 만족시키도록
    하는 표본갯수를 구해보세요. (단, 모분포의 표준편차는 모른다고 가정한다.)
    IQR 과 상자그림
    주어진 데이터를 사용하여 다음의 물음에 답하세요.
    12, 15, 14, 10, 18, 20, 21, 15, 17, 19, 10, 13, 16, 22, 50, 70
    1. 첫 번째와 세 번째 사분위수(Q1, Q3)를 계산하세요.
    2. Interquartile Range (IQR)를 계산하세요.
    3. 이상치를 식별하고, 이들을 데이터 세트에서 찾아내세요.
    4. 데이터의 상자그림(Boxplot)을 그리세요.
    """