def s5():
    """
    제 5 장
    카이제곱 검정 친해지기
    5.1 카이제곱 분포에 대하여
    “확률변수 𝑋가 자유도가 𝜈 인 카이제곱분포를 따른다.”라는 것은 다음과 같이 표현합니다.
    𝑋 ∼ 𝜒2
    (𝜈)
    카이제곱 분포는 자유도 𝜈 만 주어지면 확률밀도함수를 그릴 수 있습니다.
    𝑓(𝑥; 𝜈) = 1
    2
    𝑘/2Γ(𝑘/2) 𝑥
    𝑘/2−1𝑒
    −𝑥/2
    카이제곱 분포의 특징
    카이제곱 분포는 확률밀도함수를 통해 그 특징을 파악할 수 있습니다. 첫 번째로, 카이제곱 분포의
    확률변수는 항상 0 이상의 값을 가집니다. 이는 카이제곱 분포가 음수 값을 가지지 않는다는 것을
    의미합니다. 두 번째로, 분포의 형태는 오른쪽으로 치우쳐져 있습니다.
    • 항상 0보다 큰 값이 나오는 확률변수
    • 오른쪽으로 치우진 분포
    import numpy as np
    import matplotlib.pyplot as plt
    from scipy.stats import chi2
    k = np.arange(0,30.1,0.1)
    y = chi2.pdf(k, 6)
    plt.plot(k, y)
    plt.show()
    카이제곱 검정 친해지기 | 93
    0 5 10 15 20 25 30
    0.00
    0.02
    0.04
    0.06
    0.08
    0.10
    0.12
    0.14
    카이제곱분포와 표준정규분포의 관계
    카이제곱 분포와 표준정규분포 사이의 관계는 통계학에서 중요한 개념 중 하나입니다. 특히, 표준정
    규분포의 확률변수 𝑘개를 각각 제곱하여 합하면, 그 결과는 자유도가 𝑘인 카이제곱분포를 따르게
    됩니다.
    𝑍
    2
    1 + 𝑍2
    2 + ⋯ + 𝑍2
    𝑘 ∼ 𝜒2
    (𝑘)
    여기서 (𝑍1
    , 𝑍2
    , … , 𝑍𝑘
    )은 표준정규분포를 따르는 확률변수들이며, 𝜒
    2
    (𝑘)는 자유도가 𝑘인 카이
    제곱분포를 나타냅니다.
    코드로 확인해보기
    import numpy as np
    # 시드 고정
    np.random.seed(2023)
    #랜덤샘플이므로 값이 매번 바뀜
    sample = np.random.normal(0, 1, 10)
    print(np.sum(np.square(sample))) # ~ chi(10)
    ^༈ 21.859280277355396
    result = []
    for i in range(10000):
    sample = np.random.normal(0,1,10)
    result.append(np.sum(np.square(sample)))
    94 | 카이제곱 검정 친해지기
    5
    import matplotlib.pyplot as plt
    plt.hist(result, density = True)
    from scipy.stats import chi2
    k = np.arange(0,40.1,0.1)
    density_k = chi2.pdf(k,10)
    plt.plot(k, density_k, 'r')
    0 5 10 15 20 25 30 35 40
    0.00
    0.02
    0.04
    0.06
    0.08
    0.10
    카이제곱 분포와 관련된 검정들
    카이제곱 분포는 여러 통계적 검정에 사용됩니다.
    • 1 표본 분산 검정 (One‑sample chi‑squared test for variance):
    표본 분산이 특정 값과 같은지 여부를 검정합니다.
    • 카이제곱 독립성 검정 (Chi‑squared test for independence):
    두 카테고리컬 변수가 서로 독립적인지 아닌지를 검정합니다. 주어진 교차표 (contingency
    table)의 기대도수와 관측도수를 비교하여 두 변수 간의 관계를 평가합니다.
    • 카이제곱 동질성 검정 (Chi‑squared test for homogeneity):
    두 개 이상의 모집단에서 추출된 표본들의 분포 또는 비율이 동일한지 검정하는 데 사용됩니다.
    이 검정은 카이제곱 독립성 검정과 매우 유사합니다. 실제로 두 검정은 동일한 계산 방법을 사용
    하지만, 연구의 문맥과 목적에 따라 다르게 해석됩니다.
    • 카이제곱 적합도 검정 (Chi‑squared goodness‑of‑fit test):
    관측된 빈도가 특정 이론적 분포 (예: 균등 분포)를 따르는지 검정합니다. 연속형 또는 이산형
    분포에 모두 적용될 수 있습니다.
    카이제곱 분포에 대하여 | 95
    5.2 1 표본 분산 검정
    데이터를 발생시키는 모분포의 분산이 특정값과 같은지 검정합니다.
    귀무가설
    • 𝐻0
    : 𝜎
    2 ≤ 1.3
    • 𝐻𝐴: 𝜎
    2 > 1.3
    카이제곱 검정 통계량
    • 스튜던트 정리에 의하여 다음 검정통계량은 자유도가 𝑛 − 1인 카이제곱분포를 따릅니다.
    𝑇 = (𝑛 − 1)𝑆2
    𝜎
    2
    0
    ∼ 𝜒2
    𝑛−1
    판단 및 주의점
    • 검정통계량 𝑇 값과 𝜒
    2
    1−𝛼,𝑛−1 비교하거나 p‑value를 계산한 후 유의수준과 비교
    • 정규분포를 따르는 표본들에 한하여 적용합니다.
    예제 (기출: 22회 통계파트 1번)
    금속 성분 함유량 데이터 ‑ 제품에 금속 재질 함유량의 분산이 1.3을 넘으면 불량이라고 보고 있는데,
    제조사별로 차이가 난다고 제보를 받았다. 주어진 회사 제품의 분산에 대해 검정을 수행하시오. (유의
    확률 5%)
    10.67, 9.92, 9.62, 9.53, 9.14, 9.74, 8.45, 12.65, 11.47, 8.62
    chi2.cdf() 함수를 이용한 풀이
    from scipy.stats import chi2
    sample_data = [10.67, 9.92, 9.62, 9.53, 9.14, 9.74, 8.45,
    12.65, 11.47, 8.62]
    n = len(sample_data)
    sample_variance = np.var(sample_data,ddof=1) # ddof기본값이 0으로 지정
    t = (n-1) * sample_variance / 1.3
    print(t)
    ^༈ 11.626530769230774
    96 | 카이제곱 검정 친해지기
    5
    print('p༡value:',1 - chi2.cdf(t, df = n-1))
    ^༈ p༡value: 0.23519165145589116
    스튜던트 t 정리에 기반한 카이제곱 검정을 이용하여 풀기 때문에, 전제 조건인 데이터가 정규성을
    만족한다는 것을 체크해야합니다. 따라서 검정 전 정규성 검정을 선행합니다..
    5.3 독립성 검정
    표가 주어졌을 때, 두 카테고리컬 변수 간 상관성이 있는지 없는지를 분석합니다.
    독립의 개념
    통계에서 독립의 개념은 그 적용 대상에 따라서 정의가 달라진다.
    • 두 사건이 독립이라는 의미
    두 사건 A와 B가 독립이라는 의미는 특정 사건의 발생 유무가 다른 사건이 발생하는 확률에 영향이
    없는 상태를 의미합니다.
    P(𝐴 ∩ 𝐵) = P(𝐴)P(𝐵) ⟺ P(𝐴 ∣ 𝐵) = P(𝐴 ∩ 𝐵)
    P(𝐵) = P(𝐴).
    • 두 확률변수가 독립이라는 의미
    두 확률변수 𝑋, 𝑌 가 독립이라는 의미는 수학적으로 두 확률변수의 결합누적분포함수가 각각의
    누적분포함수의 곱으로 표현이 되는 것을 의미합니다.
    𝐹𝑋,𝑌 (𝑥, 𝑦) = 𝐹𝑋(𝑥)𝐹𝑌
    (𝑦) for all 𝑥, 𝑦
    • 직관적으로 이해하기: 두 확률변수가 독립이 아닐 경우, 한 변수가 갖는 값을 알면, 다른 변수의
    값을 예측하는데 도움이 됨.
    • 예: 두 개 상자 A와 B가 있다. A에는 빨간공 10개, 파란공 10개, B에는 빨간공 5개와 파란공 5
    개가 들어있다. 만약 특정 상자에서 공을 꺼냈는데 빨간공이 나왔다면, 공을 꺼낸 상자는 A일까?
    B일까?
    귀무가설 vs. 대립가설
    • 𝐻0
    : 변수들이 독립.
    • 𝐻𝐴: 변수들이 독립이 아니다.
    검정 통계량
    𝜒
    2 = ∑
    𝑖,𝑗
    (𝑂𝑖𝑗 − 𝐸𝑖𝑗)
    2
    𝐸𝑖𝑗
    ∼ 𝜒2
    (𝑟−1)(𝑐−1)
    • 𝑂𝑖𝑗: 관찰빈도
    독립성 검정 | 97
    • 𝐸𝑖𝑗: 예상빈도
    • 𝑖, 𝑗는 각 행, 열에 대한 인덱스
    • 𝑟: 전체 행 갯수
    • 𝑐: 전체 열 갯수
    • 자유도 계산에 주의하자.
    예상 빈도
    𝐸𝑖𝑗 =
    𝑖 − 𝑡ℎ 𝑟𝑜𝑤 𝑡𝑜𝑡𝑎𝑙 × 𝑗 − 𝑡ℎ 𝑐𝑜𝑙𝑢𝑚𝑛 𝑡𝑜𝑡𝑎𝑙
    𝑡𝑎𝑏𝑙𝑒 𝑡𝑜𝑡𝑎𝑙
    • 주의할 점! 모든 칸의 예상 빈도가 5 이상인지 체크해야 합니다.
    예제 문제
    흡연 데이터
    다음은 운동 선수 18명, 일반인 10명에 대하여 흡연 여부를 조사한 데이터이다. 운동 선수와 흡연 여부
    간의 독립성 검정을 수행하시오.
    표 5.1: 운동선수 흡연율
    Info. Non‑smoker Smoker Total
    Athlete 14 4 18
    Non‑athlete 0 10 10
    Total 14 14 28
    예상 빈도
    주어진 데이터를 사용하여 예상 빈도를 계산한다.
    표 5.2: 예상 빈도수
    Info. Non‑smoker Smoker
    Athlete 9 9
    Non‑athlete 5 5
    검정통계량 구하기
    주어진 표를 사용하여 다음과 같은 그룹에 대응하는 값을 계산합니다.
    • Athlete and Non‑smoker: (14−9)2
    9 = 2.78
    • Non‑athlete and Non‑smoker: (0−5)2
    5 = 5
    • Athlete and Smoker: (4−9)2
    9 = 2.78
    • Non‑athlete and Smoker: (10−5)2
    5 = 5
    98 | 카이제곱 검정 친해지기
    5
    𝑇 = ∑
    𝑖,𝑗
    (𝑂𝑖𝑗 − 𝐸𝑖𝑗)
    2
    𝐸𝑖𝑗
    = 15.55
    기각역은?
    귀무가설을 기각하는 관찰값이 발생하는 범위는 카이제곱분포의 오른쪽 끝부분이 됩니다.
    • 예상 빈도수와 차이나는 데이터들의 “제곱” 값이기 때문에 귀무가설과 벗어나는 표본들이 많을
    수록 검정통계량 값은 0에서 멀어지는 값을 갖게 됩니다.
    • 유의수준 5%에 대응하는 기각역은 3.841을 기준으로 오른쪽 영역이 됩니다.
    from scipy.stats import chi2
    quantile = chi2.ppf(0.95, df=1)
    print(quantile)
    ^༈ 3.841458820694124
    • p value는 어떻게 구할까?
    pvalue = chi2.sf(15.55, df=1)
    print(pvalue)
    ^༈ 8.035164786841964e-05
    시험 예상문제
    주어진 자료를 테이블이 아닌 일반 데이터로 줄 수 있습니다. 주어진 데이터를 조건에 맞게 분류 후,
    테이블 형식으로 작성하는 방법을 알아둬야 합니다.
    표 5.3: 예상 데이터 구조
    Petal.Length Species
    4.2 versicolor
    5.1 virginica
    5.1 virginica
    1.5 setosa
    3.0 versicolor
    3.8 versicolor
    5.9 virginica
    5.5 virginica
    4.6 versicolor
    4.3 versicolor
    독립성 검정 | 99
    데이터 전처리 과정
    꽃잎의 길이를 구분하는 기준이 4.3𝑐𝑚이라고 한다. iris 데이터에서 꽃잎의 길이와 품종이 독립인지
    검정하세요.
    import pandas as pd
    from sklearn.datasets import load_iris
    iris = load_iris()
    df = pd.DataFrame(data=iris.data, columns=iris.feature_names)
    df['Species'] = iris.target
    df['Species'] = df['Species'].map({0:"setosa", 1:"versicolor", 2:"virginica"})
    df["size"] = df["petal length (cm)"].apply(lambda x: "Small" if x < 4.3 else "Big")
    table = pd.crosstab(df["Species"], df["size"])
    print(table)
    ^༈ size Big Small
    ^༈ Species
    ^༈ setosa 0 50
    ^༈ versicolor 27 23
    ^༈ virginica 50 0
    Python에서 검정하기
    독립성 검정을 위해서 chi2_contingency() 함수를 이용합니다. chi2_contingency() 함수는 테이블을
    입력값으로 받습니다.
    • 함수의 결과를 사용하여, 데이터가 기대 빈도 조건 충족하는지 체크합니다.
    from scipy.stats import chi2_contingency
    chi2, p, df, expected = chi2_contingency(table)
    print(expected)
    ^༈ [[25.66666667 24.33333333]
    ^༈ [25.66666667 24.33333333]
    ^༈ [25.66666667 24.33333333]]
    print('X༡squared:', chi2.round(3), 'df:', 2, 'p༡value:', p.round(3))
    ^༈ X༡squared: 100.285 df: 2 p༡value: 0.0
    100 | 카이제곱 검정 친해지기
    5
    Fisher’s exact test 기대 빈도 가정이 무너졌을 경우에는 fisher_exact() 함수를 사용한다.
    import pandas as pd
    person = ["Athlete"]*9 + ["Non༡athlete"]*5
    smoke = ["Non༡smoker"]*7 + ["Smoker"]*7
    smoke_data = pd.DataFrame({"person":person, "smoke":smoke})
    table = pd.crosstab(smoke_data['person'], smoke_data['smoke'])
    print(table)
    ^༈ smoke Non༡smoker Smoker
    ^༈ person
    ^༈ Athlete 7 2
    ^༈ Non༡athlete 0 5
    from scipy.stats import fisher_exact
    chi2, p, dof, expected = chi2_contingency(table)
    odds_ratio, p = fisher_exact(table, alternative = 'two༡sided')
    print(expected)
    ^༈ [[4.5 4.5]
    ^༈ [2.5 2.5]]
    print("P༡value:", p.round(3))
    ^༈ P༡value: 0.021
    Fisher’s exact test의 핵심 아이디어는 초기하 분포를 이용하는 것입니다. 이 검정은 초기하 분포를
    사용하여 p‑value를 계산합니다.
    초기하 분포 초기하 분포는 전체 모집단이 두 그룹 (A, B)로 이루어져있고, 전체 N개 중 M개가 A
    그룹이 차지하고 있는 모집단에서 𝑛개를 뽑았을때, 그 중 𝑘개가 A 그룹에서 뽑혔을 확률을 의미한다.
    𝑝(𝑘; 𝑁, 𝐾, 𝑛) =
    (
    𝑀
    𝑘
    )(𝑁−𝑀
    𝑛−𝑘 )
    (
    𝑁
    𝑛
    )
    따라서 주어진 데이터에서 p‑value를 계산하는 방법은 다음과 같습니다. 9명이 운동선수 (그룹 A)
    이고, 전체 14개로 이루어진 모집단에서 7명을 뽑았을때, 7명이 모두 운동선수일 확률과
    독립성 검정 | 101
    𝑝 =
    (
    9
    7
    ) ( 5
    0
    )
    (
    14
    7
    )
    14명 중 7명을 뽑았을 때 그 중 2명이 운동 선수, 5명이 운동 선수가 아닐 확률을 더해 줍니다.
    𝑝 =
    (
    9
    2
    ) ( 5
    5
    )
    (
    14
    7
    )
    import scipy.special as sp
    p1 = (sp.comb(9, 7) * sp.comb(5, 0) / sp.comb(14, 7))
    p2 = (sp.comb(9, 2) * sp.comb(5, 5) / sp.comb(14, 7))
    print(p1 + p2)
    ^༈ 0.02097902097902098
    print(p1 * 2)
    ^༈ 0.02097902097902098
    5.4 동질성 검정
    두 개 이상의 모집단에서 추출된 표본들의 카테고리 분포 또는 비율이 동일한지 검정합니다. 데이터는
    교차표 (contingency table) 형태로 제공되며, 각 셀에는 해당 카테고리에 속하는 관측치의 수가
    포함됩니다.
    • 귀무 가설 (𝐻0
    ): 모든 모집단에서 카테고리별 비율은 동일하다.
    • 대립 가설 (𝐻𝐴): 적어도 한 모집단에서 카테고리별 비율이 다르다.
    예제 문제
    두 도시 (도시 X와 도시 Y)에서 선호하는 음료의 종류 (콜라, 사이다, 주스)를 조사하려고 합니다. 각
    도시에서 100명씩 조사한 결과를 바탕으로 두 도시의 음료 선호도가 동일한지 카이제곱 동질성 검정을
    사용하여 확인하려고 합니다.
    102 | 카이제곱 검정 친해지기
    5
    콜라 사이다 주스
    도시 X 50 30 20
    도시 Y 45 35 20
    이러한 데이터를 바탕으로 카이제곱 동질성 검정을 수행하여 두 도시의 음료 선호도가 동일한지
    검정할 수 있습니다. 여기서 카테고리는 음료가 되고, 표본집단은 도시가 됩니다.
    귀무 가설 및 대립 가설 설정
    • 귀무 가설 (𝐻0
    ): 두 도시 (도시 X와 도시 Y)에서의 음료 선호도는 동일하다.
    • 대립 가설 (𝐻𝐴): 두 도시에서의 음료 선호도는 동일하지 않다.
    기대 빈도 계산
    두 도시에서의 음료 선호도가 동일하다고 가정하면, 각 음료의 기대 확률은 다음과 같습니다.
    • 콜라: 50+45
    200 = 0.475
    • 사이다: 30+35
    200 = 0.325
    • 주스: 20+20
    200 = 0.2
    그 다음 각 도시의 총 사람수를 곱해서 콜라, 사이다, 주스를 좋아하는 사람들의 기대값을 구할 수
    있습니다. 두 도시의 총 인원이 100명으로 동일하므로, 47.5, 32.5, 20으로 계산합니다.
    주의사항
    두 도시의 음료 선호도가 동일하다는 것이, 콜라, 사이다, 주스를 동일한 1/3 비율로 좋아한다는
    의미가 아님에 주의합니다. 두 도시의 사람들이 콜라, 사이다, 주스를 좋아하는 분포가 동일한 것을
    가정한다는 의미입니다.
    카이제곱 통계량 계산
    카이제곱 통계량은 각 카테고리별로 (𝑂𝑏𝑠−𝐸𝑥𝑝)2
    𝐸𝑥𝑝 의 합으로 계산됩니다.
    𝑄 = ∑
    𝑖=1
    ∑
    𝑗=1
    (𝑦𝑖𝑗 − 𝑛𝑖 𝑗
    ̂𝑝 )
    2
    𝑛𝑖 𝑗
    ̂𝑝
    검정통계량 𝑄는 자유도가 𝑘 − 1인 카이제곱분포를 따른다고 알려져 있습니다. 𝑘는 카테고리
    개수를 의미합니다. 또한 각 카테고리 선호도는 관측치 합과 각 표본들의 값을 분수꼴로 표현하여
    추정할 수 있습니다.
    𝑗
    ̂𝑝 =
    𝑦1𝑗 + 𝑦2𝑗
    𝑛1 + 𝑛2
    자세한 내용은 다음 자료를 참고해주세요.
    https://online.stat.psu.edu/stat415/lesson/17/17.1
    동질성 검정 | 103
    p‑value 계산 및 결론 도출
    카이제곱 통계량 값을 카이제곱 분포에 대입하여 p‑value를 계산합니다. p‑value가 특정 유의 수준
    (예: 0.05)보다 작으면 귀무가설을 기각하고, 두 도시에서의 음료 선호도는 동일하지 않다고 결론을
    내릴 수 있습니다. 그렇지 않으면 귀무가설을 기각할 수 없습니다.
    import numpy as np
    from scipy.stats import chi2_contingency
    # 데이터 설정: 교차표
    data = np.array([[50, 30, 20], # 도시 X
    [45, 35, 20]]) # 도시 Y
    chi2, p, df, expected = chi2_contingency(data)
    print(chi2.round(3), p.round(3))
    ^༈ 0.648 0.723
    5.5 적합도 검정
    내가 관찰한 데이터가 이론적인 분포를 따르는지 검정합니다. 데이터는 역시 교차표 (contingency
    table) 형태로 제공되며, 각 셀에는 해당 카테고리에 속하는 관측치의 수가 포함됩니다.
    • 귀무 가설 (𝐻0
    ): 데이터의 모집단이 특정 분포를 따른다.
    • 대립 가설 (𝐻𝐴): 데이터의 모집단이 특정 분포를 따르지 않는다.
    자료 및 검정 예시
    다음은 140명의 신생아들의 태어난 날을 조사하여 작성한 표입니다. 카이제곱 적합도 검정을 이용하여
    특정 요일에 아이들이 더 많이 태어나는지 검정할 수 있습니다.
    표 5.5: 요일별 출생아 수
    요일 월 화 수 목 금 토 일
    출생수 13 23 24 20 27 18 15
    귀무가설 vs 대립가설
    • 𝐻0
    : 요일별 신생아 출생 비율이 같다.
    – 𝑝1 = 𝑝2 = ... = 𝑝7 =
    1
    7
    • 𝐻𝐴: 요일별 신생아 출생 비율이 모두 같지는 않다.
    – Not all 𝑝𝑖 =
    1
    7
    104 | 카이제곱 검정 친해지기
    5
    검정통계량
    • 앞에서 배운 카이제곱 검정 통계량과 같음. 자유도가 바뀜에 주의하자.
    𝑇 = ∑
    𝑖
    (𝑂𝑖 − 𝐸𝑖
    )
    2
    𝐸𝑖
    ∼ 𝜒2
    𝑛−1
    위의 검정통계량 값을 앞에서 배운 chisq.test()를 사용해서 구할 수 있다. 먼저 데이터를 입력하
    도록 한다. matrix() 함수를 사용하여 데이터를 입력 후, 열과 행 이름을 부여한 후 테이블 오브젝트로
    변환한다.
    from scipy.stats import chisquare
    import numpy as np
    observed = np.array([13, 23, 24, 20, 27, 18, 15])
    expected = np.repeat(20, 7)
    statistic, p_value = chisquare(observed, f_exp=expected)
    print("Test statistic: ", statistic.round(3))
    ^༈ Test statistic: 7.6
    print("p༡value: ", p_value.round(3))
    ^༈ p༡value: 0.269
    데이터 입력을 마쳤으므로, chisquare()를 사용하여 검정을 진행할 수 있다.
    검정통계량에 대응하는 P‑value 0.2688이 유의수준 5%보다 크므로, 귀무가설을 기각하지 못한다.
    따라서 각 요일별 신생아 출생율은 모두 같다고 판단한다.
    또한, 아래와 같이 각 셀의 기대빈도가 5보다 모두 크므로, 카이제곱검정의 결과를 신뢰할 수 있다고
    판단한다.
    print("Expected: ", expected)
    ^༈ Expected: [20 20 20 20 20 20 20]
    5.6 비율 검정
    비율 검정 역시 표본이 1개, 2개, 그리고 3개 이상인 경우에 따라서 달라집니다.
    1표본 자료 및 검정 예시
    다음은 어느 마을을 대상으로 원자력 발전소 건설에 찬성과 반대를 조사한 데이터이다. 마을 전체
    사람들의 찬성 비율이 50%보다 높은지 검정하시오.
    비율 검정 | 105
    표 5.6: 원자력 발전소 설문
    설문조사 찬성 반대
    결과 45 37
    귀무가설 vs. 대립가설
    • 𝐻0
    : 𝑝 = 𝑝0
    vs. 𝐻𝐴: 𝑝 ≠ 𝑝0
    • 𝐻0
    : 𝑝 ≤ 𝑝0
    vs. 𝐻𝐴: 𝑝 > 𝑝0
    • 𝐻0
    : 𝑝 ≥ 𝑝0
    vs. 𝐻𝐴: 𝑝 < 𝑝0
    위의 선택지 중 2번째 형태의 가설을 설정해야 한다.
    • 𝐻0
    : 𝑝 ≤ 0.5 vs. 𝐻𝐴: 𝑝 > 0.5
    • 𝐻0
    : 마을의 원자력 발전소 찬성 비율은 0.5 보다 낮거나 같다.
    • 𝐻𝐴: 마을의 원자력 발전소 찬성 비율은 0.5 보다 높다.
    검정통계량
    귀무가설이 참이라는 전제하에 다음의 검정통계량 𝑍 는 표준정규분포를 따른다.
    𝑍 = ̂𝑝 − 𝑝0
    √𝑝0
    𝑞0/𝑛
    ∼ 𝒩(0, 12
    )
    • 위 검정은 이항분포를 따르는 확률변수가 특정 조건을 만족할 때 정규분포로 근사시킬 수 있다는
    사실에 기반한다.
    • 𝑋 ∼ 𝐵(𝑛, 𝑝)를 따를 때, 𝑛𝑝 ≥ 10이고, 𝑛(1 − 𝑝) ≥ 10 조건을 만족하는 경우, 다음이
    성립한다.
    𝑋 ≈ 𝒩(𝑛𝑝, 𝑛𝑝(1 − 𝑝))
    • 코드로 구해보기
    p_hat = 45/82
    z = (p_hat-0.5) / np.sqrt(0.5 * 0.5 / 82)
    z
    ^༈ 0.8834522085987732
    기각역
    대립 가설에 따라 기각역을 norm.ppf()을 사용해 계산할 수 있다. 유의수준 5%인 단측 검정에 해당하
    는 기각역은 다음과 같습니다.
    106 | 카이제곱 검정 친해지기
    5
    from scipy.stats import norm
    rounded_quantile = round(norm.ppf(0.975), 3)
    print("{} 이상".format(rounded_quantile))
    ^༈ 1.96 이상
    print("{} 이하".format(-rounded_quantile))
    ^༈ -1.96 이하
    위에 주어진 검정통계량 0.883는 기각역에 속하지 않으므로, 5% 유의수준 하에서 귀무가설을
    기각하지 못한다고 판단합니다.
    Python에서 검정하기
    주어진 상황에 맞게 binom_test()와 proportions_ztest() 함수 중 선택하여 사용한다.
    • 조건: 𝑛𝑝0와 𝑛(1 − 𝑝0
    ) 모두 10 이상이다.
    proportions_ztest() 사용하는 경우 조건을 만족하는 경우, 정규분포 근사가 가능하여 𝑍 검정통계
    량을 사용하여 검정할 수 있다. proportions_ztest() 함수는 카이제곱검정 통계량을 계산해주는데,
    이는 앞에서 구한 𝑍 통계량을 제곱한 값이다.
    from statsmodels.stats.proportion import proportions_ztest
    z_score, p_value = proportions_ztest(45, 82, 0.5, alternative='larger')
    print("x༡sqaured:",z_score^*2)
    ^༈ x༡sqaured: 0.7879879879879893
    print("p༡value:",p_value)
    ^༈ p༡value: 0.1873546039633795
    print('sqrt_z༡score',z_score)
    ^༈ sqrt_z༡score 0.8876868749666119
    위 조건 불만족시 binom_test()를 사용한다.
    비율 검정 | 107
    binom_test() 사용하는 경우 정확하게 성공횟수가 이항분포를 따른다는 전제하에 검정통계량을
    계산해준다.
    from scipy.stats import binom_test
    p_value = binom_test(x=45, n=82, p=0.5, alternative='greater')
    print(p_value)
    ^༈ 0.219852714592911
    이항분포 𝑛 = 82, 𝑝 = 0.5를 따르는 분포하에서 찬성 표 45이상을 받게 될 확률이 p‑value값이
    된다.
    from scipy.stats import binom
    prob_x_or_less = binom.cdf(44, 82, 0.5)
    prob_x_or_more = 1 - prob_x_or_less
    print(prob_x_or_more)
    ^༈ 0.219852714592911
    비율 추정 신뢰구간
    유의수준 𝛼 혹은 신뢰수준 𝐶 = 1−𝛼에 대응하는 모비율 𝑝에 대한 신뢰구간을 구하는 공식은 다음과
    같다.
    ̂𝑝 ± 𝑧𝛼/2𝑆.𝐸. ̂𝑝
    = ̂𝑝 ± 𝑧𝛼/2√ ̂𝑝(1 − ̂𝑝)
    𝑛
    위 식에서 𝑧𝛼/2는 표준정규분포에서 다음을 조건을 만족하는 임계값이며,
    𝑃 (|𝑍| > 𝑧𝛼/2) = 1 − 𝐶 = 𝛼
    𝑆.𝐸. ̂𝑝는 표본 비율 통계량의 표준오차를 의미한다. 또한, 임계값 𝑧𝛼/2와 표준오차 𝑆.𝐸. ̂𝑝의 곱을
    margin of error (허용오차 혹은 표본 오차범위) 라고 부른다.
    표본 갯수 구하기
    모비율의 구간추정 문제에서 추정의 허용오차를 특정 수준으로 맞추기 위하여, 필요한 최소한의 표본
    갯수를 구하는 문제가 나오기도 한다. 이런 경우, ̂𝑝 값을 데이터에서 구한 값으로 대채하는 경우와
    최대값인 0.5로 놓고 계산하는 경우 2가지로 나뉜다.
    108 | 카이제곱 검정 친해지기
    5
    Type 1 다음은 어느 마을을 대상으로 원자력 발전소 건설에 찬성과 반대를 사전 조사한 데이터이다.
    마을 전체 사람들의 찬성 비율 𝑝에 대한 90% 신뢰구간의 허용오차가 2% 이하가 되도록하는 최소한의
    표본을 조사하려 한다. 몇명의 사람들을 더 조사해야할까?
    찬성 반대
    450 370
    다음을 만족하는 𝑛의 최소 정수값을 구하면 된다.
    𝑧𝛼/2√ ̂𝑝(1 − ̂𝑝)
    𝑛
    ≤ 0.02
    따라서,
    ̂𝑝(1 − ̂𝑝)
    (
    0.02
    𝑧𝛼/2 )
    2 ≤ 𝑛
    from scipy.stats import norm
    p_hat = 450 / (450+370)
    p_hat * (1-p_hat) / (0.02 / norm.ppf(0.95))^*2
    ^༈ 1674.8698137525512
    즉, 총 1675명이 필요하므로, 855명이 추가적으로 더 필요하다.
    Type 2 어느 마을을 대상으로 원자력 발전소 건설에 찬성 비율을 추정하려고 한다. 마을 전체 사람들
    의 찬성 비율 𝑝에 대한 95% 신뢰구간의 허용오차가 3% 이하가 되도록하는 최소한의 표본을 조사하려
    한다. 몇명의 사람들을 조사해야할까?
    p_hat = 0.5
    p_hat * (1 - p_hat) / (0.03 / norm.ppf(0.975))^*2
    ^༈ 1067.0718946372572
    총 1068명의 표본이 필요하다.
    이론적 신뢰구간과 실제 구현된 신뢰구간의 차이점
    proportions_ztest() 함수를 사용한 신뢰구간과 우리가 알고있는 계산식으로 구한 신뢰구간 값이
    차이가 나는 것을 알 수 있다.
    비율 검정 | 109
    from statsmodels.stats.proportion import proportions_ztest, proportion_confint
    z_score, p_value = proportions_ztest(45, 82, 0.5, alternative='two༡sided')
    conf_int = proportion_confint(45, 82, alpha=0.05)
    print("confidence interval:",conf_int)
    ^༈ confidence interval: (0.44107584336090966, 0.6564851322488465)
    기초 통계 시간에 배우는 신뢰구간의 경우, 다음과 같이 구할 수 있다.
    from scipy.stats import norm, chi2
    import math
    sqrt_qchisq = math.sqrt(chi2.ppf(0.95, 1))
    print(sqrt_qchisq)
    ^༈ 1.9599639845400538
    print(p_hat - norm.ppf(0.975) * math.sqrt((p_hat * (1-p_hat)) / 82))
    ^༈ 0.39177909306775244
    print(p_hat + norm.ppf(0.975) * math.sqrt((p_hat * (1-p_hat)) / 82))
    ^༈ 0.6082209069322475
    결과을 비교해보면 비슷하게 나오는 것을 알 수 있지만, proportions_ztest()의 정확한 신뢰 구간을
    구하기 위해서는 Wilson이 제안한 상당히 복잡한 수식의 신뢰구간을 사용한다.
    ⎛⎜⎜
    ⎝
    ̂𝑝 + 𝑧
    2
    𝛼/2
    2𝑛 − 𝑧𝛼/2√ ̂𝑝 ̂𝑞
    𝑛 +
    𝑧
    2
    𝛼/2
    4𝑛2
    1 + 𝑧
    2
    𝛼/2
    𝑛
    ,
    ̂𝑝 + 𝑧
    2
    𝛼/2
    2𝑛 + 𝑧𝛼/2√ ̂𝑝 ̂𝑞
    𝑛 +
    𝑧
    2
    𝛼/2
    4𝑛2
    1 + 𝑧
    2
    𝛼/2
    𝑛
    ⎞⎟⎟
    ⎠
    𝑧𝛼는 유의수준 𝛼에 해당하는 임계값으로 다음을 만족하는 값이다.
    𝑃(𝑍 > 𝑧𝛼) = 𝛼
    2표본 자료 및 검정 예시
    다은 서울과 제주에서 과속 여부에 대한 자료이다. 사람들이 두 지역에 따라 과속 비율이 달라지는지
    여부에 대하여 검정하시오.
    110 | 카이제곱 검정 친해지기
    5
    표 5.8: 지역별 과속 비율 조사
    지역 과속 운전자
    서울 145 300
    제주 78 200
    귀무가설 vs. 대립가설
    위의 주어진 검정의 경우, 다음과 같이 귀무가설과 대립가설을 설정할 수 있습니다.
    • 𝐻0
    : 지역별 과속 비율(𝑝1
    ∶ 𝑆𝑒𝑜𝑢𝑙, 𝑝2
    ∶ 𝐽𝑒𝑗𝑢)이 같다.
    – 𝑝1 = 𝑝2
    • 𝐻𝐴: 지역별 과속 비율(𝑝1
    ∶ 𝑆𝑒𝑜𝑢𝑙, 𝑝2
    ∶ 𝐽𝑒𝑗𝑢)은 같지 않다.
    – 𝑝1 ≠ 𝑝2
    검정통계량
    귀무가설이 참이라는 전제 하에 다음의 검정통계량 𝑍 는 표준정규분포를 따른다.
    𝑍 = 1
    ̂𝑝 − ̂𝑝2
    √ ̂𝑝(1 − ̂𝑝) ( 1
    𝑛1
    +
    1
    𝑛2
    )
    ∼ 𝒩(0, 12
    )
    x = [145, 78]
    n = [300, 200]
    z_score, p_value = proportions_ztest(count = x, nobs = n)
    print("x༡squared:", z_score^*2)
    ^༈ x༡squared: 4.230679984674577
    print("p༡value:", p_value.round(3))
    ^༈ p༡value: 0.04
    정말 위와 같은 검정통계량 공식을 사용하여 계산되는지 확인해보면 다음과 같이 구할 수 있다.
    p1 = 145/300
    p2 = 78/200
    p_hat = (145+78) / 500
    z = (p1-p2) / np.sqrt(p_hat*(1-p_hat)*(1/300 + 1/200))
    z^*2
    ^༈ 4.230679984674577
    비율 검정 | 111
    5.7 연습문제
    휴대전화 사용자들의 정치 성향은 다를까?
    다음은 휴대전화와 유선전화를 모두 사용하는 사용자들과 유선전화만을 사용하는 사용자들의 정치
    성향을 조사한 데이터이다. 정당 지지와 핸드폰 사용 유무 사이에 상관성을 검정해보세요.
    표 5.9: 정치 성향 설문조사 결과
    정당지지 핸드폰 유선전화
    진보 49 47
    중도 15 27
    보수 32 30
    여자아이 vs. 남자아이
    다음은 4자녀를 둔 130가구를 조사하여 여자아이의 수를 조사한 자료이다. 여자 아이의 출생 비율이
    50% 인지 유의수준 5%하에서 검정해보세요.
    표 5.10: 4자녀 가정 여자아이 숫자 조사 결과
    Girl Frequency
    0 10
    1 31
    2 44
    3 34
    4 11
    지역별 대선 후보의 지지율
    어느 도시에 있는 3개의 선거구에서 특정후보 A를 지지하는 유권자의 비율을 비교하기 위해 각 선거
    구에서 300명을 무작위를 추출하여 조사한 데이터이다. 주어진 데이터를 대상으로 후보A를 지지하는
    비율이 3개 선거구 간에 차이가 있는지를 5% 유의수준에서 검정하라.
    표 5.11: 지역별 대선 후보의 지지율
    구분 선거구 1 선거구 2 선거구 3
    지지함 176 193 159
    지지하지 않음 124 107 141
    데이터가 특정분포를 따를까?
    다음의 데이터가 주어졌을때, 카이제곱 검정법을 사용하여 데이터가 모수가 2인 지수분포를 따르는지
    유의수준 5% 하에서 검정해보세요.
    112 | 카이제곱 검정 친해지기
    5
    0.211, 0.098, 0.736, 0.091, 0.756, 1.039, 0.391, 0.172, 2.113, 0.013, 0.073, 0.812, 0.132,
    0.263, 0.124, 0.339, 0.092, 0.24, 0.438, 0.584, 0.722, 0.231, 0.033, 0.203, 0.177, 0.095, 0.352,
    0.023
    • 데이터는 3개 구간 (0, 0.2], (0.2, 0.4], (0.4, Inf )을 사용해서 검정하세요.
    설문조사 환자 수
    슬통 병원에서는 최근 도입한 진료 서비스에 대한 환자 만족도를 평가하고자 합니다. 병원은 환자들에
    게 만족도 설문지를 무작위로 분배하려고 합니다. 설문을 시작하기 전에, 병원은 적절한 표본 크기를
    결정하려고 합니다.
    설문지는 환자의 진료 서비스에 대한 만족도를 7점 척도로 묻습니다. 병원은 특히 환자 중 만족하거
    나 매우 만족하는 비율 𝑝에 관심이 있습니다 (이는 7점 척도 중 상위 두 단계에 해당합니다).
    병원은 만족도 추정의 신뢰 수준을 95%로 설정하려고 하며, 오차 범위는 3% 또는 0.03 이하로 원
    합니다. 보수적인 추정을 위하여 확률은 0.5로 가정하고자 합니다. 조건 만족을 위하여 설문에 필요한
    최소 환자 수를 구해주세요.
    설문조사 환자 수 2
    다음은 슬통 병원에서 작년에 조사해놓은 환자들의 만족도 조사 결과 입니다.
    7, 7, 6, 7, 6, 3, 6, 4, 5, 2, 7, 6, 6, 6, 6, 6, 6, 6, 7, 6
    위의 데이터를 사용하여 설문에 필요한 최소 환자 수를 구해주세요. 병원은 만족도 추정의 신뢰
    수준을 98%로 설정하려고 하며, 오차 범위는 2% 또는 0.02 이하로 원합니다.
    유권자의 마음
    슬통 신문사에서는 다음과 같은 42명의 시민들을 대상으로 지난 1월 A 대통령 후보를 지지하는 조사
    하였습니다. 다음은 대통령이 된 A 후보의 임기 시작 후 6개월이 지난 오늘, 다시 한번 동일 인원들에게
    전화를 걸어 대통령 후보를 지지하는지 물어본 결과입니다.
    당선 후 지지여부
    당선 전 지지여부 지지함 지지하지 않음
    지지함 17 7
    지지하지 않음 5 13
    사람들의 A 후보에 대한 지지율이 당선 전과 당선 후 변하였는지 검정해보세요.
    연습문제 | 113
    """